﻿---
-- Default values for the player saved variables
---
sConfig = {
	general = {
		allowDrag = true,
		allowSettingsClick = true,
		useEnglish = false
	},
	messages = {
		playerFloating = true,
		playerChat = false,
		petFloating = true,
		petChat = false
	},
	averageDisplay = {
		visible = true,
		backdrop = true,
        header = true,
		playerKills = true,
		playerQuests = true,
		petKills = true
	},
	ldb = {
		customColors = true,
		showIcon = true,
		showLabel = false,
		showText = false,
		text = {
			playerKills = true,
			playerQuests = true,
			petKills = true,
			xpPogress = true
		},
		tooltip = {
			showDetails = true,
			showExperience = true
		}
	}
}
sData = {
	player = {
		killAverage = 0,
		questAverage = 0
	},
	pet = {
		killAverage = 0
	}
}

---
-- Verifies that all config values have a default value
-- (New values are sometimes not initialized if older versions of saved values exist)
---
function VerifyConfig()
	-- General
	if sConfig.general == nil then sConfig.general = {  } end
	if sConfig.general.allowDrag == nil then sConfig.general.allowDrag = true end
	if sConfig.general.allowSettingsClick == nil then sConfig.general.allowSettingsClick = true end
	if sConfig.general.useEnglish == nil then sConfig.general.useEnglish = false end
	
	-- Messages
	if sConfig.messages == nil then sConfig.messages = {  } end
	if sConfig.messages.playerFloating == nil then sConfig.messages.playerFloating = true end
	if sConfig.messages.playerChat == nil then sConfig.messages.playerChat = false end
	if sConfig.messages.petFloating == nil then sConfig.messages.petFloating = true end
	if sConfig.messages.petChat == nil then sConfig.messages.petChat = false end
	
	-- averageDisplay
	if sConfig.averageDisplay == nil then sConfig.averageDisplay = {  } end
	if sConfig.averageDisplay.visible == nil then sConfig.averageDisplay.visible = true end
	if sConfig.averageDisplay.backdrop == nil then sConfig.averageDisplay.backdrop = true end
	if sConfig.averageDisplay.header == nil then sConfig.averageDisplay.header = true end
	if sConfig.averageDisplay.playerKills == nil then sConfig.averageDisplay.playerKills = true end
	if sConfig.averageDisplay.playerQuests == nil then sConfig.averageDisplay.playerQuests = true end
	if sConfig.averageDisplay.petKills == nil then sConfig.averageDisplay.petKills = true end

	-- LDB
	if sConfig.ldb == nil then sConfig.ldb = {  } end
	if sConfig.ldb.text == nil then sConfig.ldb.text = {  } end
	if sConfig.ldb.tooltip == nil then sConfig.ldb.tooltip = {  } end
	if sConfig.ldb.customColors == nil then sConfig.ldb.customColors = true end
	if sConfig.ldb.showIcon == nil then sConfig.ldb.showIcon = true end
	if sConfig.ldb.showLabel == nil then sConfig.ldb.showLabel = false end
	if sConfig.ldb.showText == nil then sConfig.ldb.showText = true end
	if sConfig.ldb.text.playerKills == nil then sConfig.ldb.text.playerKills = true end
	if sConfig.ldb.text.playerQuests == nil then sConfig.ldb.text.playerQuests = true end
	if sConfig.ldb.text.petKills == nil then sConfig.ldb.text.petKills = true end
	if sConfig.ldb.text.xpPogress == nil then sConfig.ldb.text.xpPogress = true end
	if sConfig.ldb.tooltip.showDetails == nil then sConfig.ldb.tooltip.showDetails = true end
	if sConfig.ldb.tooltip.showExperience == nil then sConfig.ldb.tooltip.showExperience = true end
end