﻿-- Current locale
LOCALE_CLIENT = GetLocale()
LOCALE_DISPLAY = LOCALE_CLIENT

if sConfig.general.useEnglish then
    LOCALE_DISPLAY = "enUS"
end

-- Allowed locales
LOCALE_SUPPORTED = { 
	enUS = true,
	frFR = true,
	deDE = true,
	esES = true,
	ruRU = "XToLevel не смогло быть нагружено. Русский клиент не поддержан."
};

-- XP gain regular expressions
LOCALE_XPGAIN_MSG = {
	enUS = "You gain (%d+) experience",
	frFR = "Vous gagnez (%d+) points d'expérience",
	deDE = "Ihr bekommt (%d+) Erfahrung",
	esES = "Obtienes (%d+) p. de experiencia"
};
LOCALE_KILL_MSG = { 
	enUS = "(.+) dies, you gain (%d+) experience",
	frFR = "(.+) meurt, vous gagnez (%d+) points d'expérience",
	deDE = "(.+) stirbt, Ihr bekommt (%d+) Erfahrung",
	esES = "(.+) muere, obtienes (%d+) p. de experiencia"
};

-- UI messages
LOCALE_MESSAGES = {
	enUS = {
		Kills = "Kills",
		Quests = "Quests",
		Pet = "Pet",
		LevelReached = "Level reached. Congratulations!",
		QuestsNeeded = " more quests like that needed to level",
		KillsNeeded = " needed to level",
		PetKillsNeeded = " needed for "
	},
	frFR = {
		Kills = "Mobs",
		Quests = "Quétes",
		Pet = "Familier",
		LevelReached = "Le niveau a atteint. Félicitations!",
		QuestsNeeded = " plus de recherches nécessaire niveler",
		KillsNeeded = " nécessaire pour niveler",
		PetKillsNeeded = " requises pour "
	},
	deDE = {
		Kills = "Tötungen",
		Quests = "Suches",
		Pet = "Tier",
		LevelReached = "Niveau erreicht. Glückwünsche!",
		QuestsNeeded = " ehr sucht erforderlich, um zu ebnen",
		KillsNeeded = " erforderlich ebnen",
		PetKillsNeeded = " brauchten für "
	},
	esES = {
		Kills = "Criaturas",
		Quests = "Misiones",
		Pet = "Mascota",
		LevelReached = "Nivel alcanzado. Felicidades!",
		QuestsNeeded = " más misiones como la que es necesario nivel",
		KillsNeeded = " necesarias para alcanzar el próximo nivel",
		PetKillsNeeded = " necesarios para "
	}
};

LOCALE_CONFIG_TEXT = {
	enUS = {
		Title = "XToLevel Config",
		Categories = {
			General = {
				Name = "General",
				UseEnglish = "Use English"
			},
			Messages = {
				Name = "Messages",
				PlayerMessagesLabel = "Player messages",
				PetMessagesLabel = "Pet messages",
				ShowInChat = "Show in default chat window",
				ShowFloating = "Show floating messages"
			},
			AverageDisplay = {
				Name = "Average display",
				BehaviorLabel = "Behavior",
				AppearenceLabel = "Appearence",
				DataLabel = "Data",
				LockAverageDisplay = "Lock the average display window",
				AllowSettingsClick = "Allow right click to open settings",
				ShowAverageDisplay = "Show average display",
                ShowHeader = "Show XToLevel label",
				ShowFrame = "Show window frame",
				ShowKills = "Show kill average",
				ShowQuests = "Show quest average",
				ShowPet = "Show pet kill average"
			},
			LDB = {
				Name = "LDB Display",
				UseCustomColors = "Color Text",
				ShowIcon = "Show Icon",
				ShowLabel = "Show Label",
				ShowText = "Show Text",
				GeneralLabel = "General",
				TextLabel = "Text",
				TooltipLabel = "Tooltip",
				ShowTextKills = "Show Kills",
				ShowTextQuests = "Show Quests",
				ShowTextPet = "Show Pet Kills",
				ShowTextXP = "Show XP Progress",
				ShowTooltipDetails = "Show Details",
				ShowTooltipExperience = "Show Experience"
			}
		}
	},
	frFR = {
		Title = "Config de XToLevel",
		Categories = {
			General = {
				Name = "General",
				UseEnglish = "Use English"
			},
			Messages = {
				Name = "Messages",
				PlayerMessagesLabel = "Messages de joueur",
				ShowInChat = "Montrez dans la fenêtre de causerie de défaut",
				ShowFloating = "Montrez les messages de flottement"
			},
			AverageDisplay = {
				Name = "Affichage moyen",
				BehaviorLabel = "Comportement",
				AppearenceLabel = "Aspect",
				DataLabel = "Données",
				LockAverageDisplay = "Verrouillage de la moyenne fenêtre d'affichage",
				AllowSettingsClick = "Autoriser un clic droit pour ouvrir les paramètres de",
				ShowAverageDisplay = "Montrez l'affichage moyen",
                ShowHeader = "Montrez XToLevel label",
				ShowFrame = "Armature de vitrine d'exposition",
				ShowKills = "Montrez la moyenne de mise à mort",
				ShowQuests = "Montrez la moyenne de recherche",
				ShowPet = "Show pet kill average"
			},
			LDB = {
				Name = "LDB Display",
				UseCustomColors = "Color Text",
				ShowIcon = "Show Icon",
				ShowLabel = "Show Label",
				ShowText = "Show Text",
				GeneralLabel = "General",
				TextLabel = "Text",
				TooltipLabel = "Tooltip",
				ShowTextKills = "Show Kills",
				ShowTextQuests = "Show Quests",
				ShowTextPet = "Show Familier Kills",
				ShowTextXP = "Show XP Progress",
				ShowTooltipDetails = "Show Details",
				ShowTooltipExperience = "Show Experience"
			}
		}
	},
	deDE = {
		Title = "XToLevel Konfiguration",
		Categories = {
			General = {
				Name = "General",
				UseEnglish = "Use English"
			},
			Messages = {
				Name = "Mitteilungen",
				PlayerMessagesLabel = "Spielermitteilungen",
				ShowInChat = "Stellen Sie innen dar Rückstellungsschwätzchenfenster",
				ShowFloating = "Zeigen Sie schwimmen Mitteilungen"
			},
			AverageDisplay = {
				Name = "Durchschnittliches Fenster",
				BehaviorLabel = "Verhalten",
				AppearenceLabel = "Aussehen",
				DataLabel = "Daten",
				LockAverageDisplay = "Verriegeln Sie die Fenster",
				AllowSettingsClick = "Erlauben Sie öffnen Einstellungen mit einem Rechtsklick ",
				ShowAverageDisplay = "Zeigen Sie durchschnittliches fenster",
                ShowHeader = "Zeigen XToLevel label",
				ShowFrame = "Zeigen Sie fensterhintergrund",
				ShowKills = "Zeigen Sie tötungdurchschnitt",
				ShowQuests = "Zeigen Sie suchendurchschnitt",
				ShowPet = "Show pet kill average"
			},
			LDB = {
				Name = "LDB Display",
				UseCustomColors = "Color Text",
				ShowIcon = "Show Icon",
				ShowLabel = "Show Label",
				ShowText = "Show Text",
				GeneralLabel = "General",
				TextLabel = "Text",
				TooltipLabel = "Tooltip",
				ShowTextKills = "Show Kills",
				ShowTextQuests = "Show Quests",
				ShowTextPet = "Show Tier Kills",
				ShowTextXP = "Show XP Progress",
				ShowTooltipDetails = "Show Details",
				ShowTooltipExperience = "Show Experience"
			}
		}
	},
	esES = {
		Title = "XToLevel Configuración",
		Categories = {
			General = {
				Name = "General",
				UseEnglish = "Use English"
			},
			Messages = {
				Name = "Mensajes",
				PlayerMessagesLabel = "Reproductor de mensajes",
				ShowInChat = "Mostrar la ventana de chat por defecto en",
				ShowFloating = "Mostrar mensajes flotante"
			},
			AverageDisplay = {
				Name = "Promedio de visualización",
				BehaviorLabel = "Comportamiento",
				AppearenceLabel = "Apariencia",
				DataLabel = "Datos",
				LockAverageDisplay = "Bloqueo de la media de visor",
				AllowSettingsClick = "Permitir el botón derecho para abrir la configuración de",
				ShowAverageDisplay = "Mostrar media de pantalla",
                ShowHeader = "Mostrar XToLevel label",
				ShowFrame = "Mostrar marco de la ventana",
				ShowKills = "Mostrar matar promedio",
				ShowQuests = "Mostrar misiones promedio",
				ShowPet = "Mostrar mascota matar promedio"
			},
			LDB = {
				Name = "LDB Exponer",
				UseCustomColors = "Color Text",
				ShowIcon = "Show Icon",
				ShowLabel = "Show Label",
				ShowText = "Show Text",
				GeneralLabel = "General",
				TextLabel = "Texto",
				TooltipLabel = "Tooltip",
				ShowTextKills = "Mostrar matar",
				ShowTextQuests = "Mostrar misiones",
				ShowTextPet = "Mostrar mascota matar",
				ShowTextXP = "Mostrar XP Progreso",
				ShowTooltipDetails = "Mostrar detalles",
				ShowTooltipExperience = "Mostrar Experiencia"
			}
		}
	}
};

LOCALE_TOOLTIP = {
	enUS = {
		Kills = " Kills: ",
		Quests = " Quests: ",
		Details = 'Details:',
		XpPerKill = ' XP per kill:',
		XpPerQuest = ' XP per quest:',
		Experience = 'Experience:',
		Progress = ' progress:',
		Required = ' XP required:',
		RequiredQuestXP = ' quest XP needed:',
		RequiredKillXP = ' kill XP needed:',
		Total = ' total:',
		Gained = ' gained:',
		Rested = ' rested:',
		Pet = 'Pet:'
	},
	frFR = {
		Kills = " Mobs: ",
		Quests = " Quétes: ",
		Details = 'Détails:',
		XpPerKill = ' XP chaque tuent:',
		XpPerQuest = ' XP chaque quétes:',
		Experience = 'Expérience:',
		Progress = ' progrès:',
		Required = ' XP nécessaire:',
		RequiredQuestXP = ' quétes XP nécessaire:',
		RequiredKillXP = ' mob XP nécessaire:',
		Total = ' total:',
		Gained = ' acquise:',
		Rested = ' reposé:',
		Pet = 'Familier:'
	},
	deDE = {
		Kills = " Tötungen: ",
		Quests = " Suches: ",
		Details = 'Details:',
		XpPerKill = ' XP pro tötung:',
		XpPerQuest = ' XP pro suche:',
		Experience = 'Erfahrung:',
		Progress = ' fortschritt:',
		Required = ' XP nötig:',
		RequiredQuestXP = ' suches XP nötig:',
		RequiredKillXP = ' tötungen XP nötig:',
		Total = ' summe:',
		Gained = ' erworben:',
		Rested = ' ruhte:',
		Pet = 'Tier:'
	},
	esES = {
		Kills = " Criaturas: ",
		Quests = " Misiones: ",
		Details = 'Detalles:',
		XpPerKill = ' XP cada matanza:',
		XpPerQuest = ' XP cada misiones:',
		Experience = 'Experiencia:',
		Progress = ' progreso:',
		Required = ' XP requerido:',
		RequiredQuestXP = ' misiones XP requerido:',
		RequiredKillXP = ' criaturas XP requerido:',
		Total = ' total:',
		Gained = ' adquirido:',
		Rested = ' descansado:',
		Pet = 'Mascota:'
	}
}