-----
-- LibDataBroker data-source
-- TODO: Clean the code up
----
local UPDATE_INTERVAL = 1
local updateIn = 0
local tooltipFrame = nil

local iconName = (UnitFactionGroup("player") == "Alliance") and "INV_Jewelry_TrinketPVP_01" or "INV_Jewelry_TrinketPVP_02"

local frame = CreateFrame("frame")
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local dataobj = ldb:NewDataObject("XToLevel", {
	type = "data source",
	icon = "Interface\\Icons\\" .. iconName,
	text = "XToLevel",
	label = "XToLevel",
})

local function FindAnchor(frame)
	local xcenter, ycenter = frame:GetCenter()
	if not xcenter or not ycenter then 
		return "TOPLEFT", "BOTTOMLEFT" 
	end
	local hor = (xcenter > UIParent:GetWidth() * 2 / 3) and "RIGHT" or (xcenter < UIParent:GetWidth() / 3) and "LEFT" or ""
	local ver = (ycenter > UIParent:GetHeight() / 2) and "TOP" or "BOTTOM"
	
	return ver..hor, frame, (ver == "TOP" and "BOTTOM" or "TOP")..hor
end

function dataobj:OnEnter()
	GameTooltip:SetOwner(self, "ANCHOR_NONE")
	GameTooltip:SetPoint(FindAnchor(self))
	GameTooltip:ClearLines()

	tooltipFrame = self
	
	local labelColor, dataColor, footerColor
	
	if sConfig.ldb.customColors then
		labelColor = { r=0.75, g=0.75, b=0.75 }
		dataColor = { r=0.9, g=1, b=0.9 }
		footerColor = { r=0.6, g=0.6, b=0.6 }
	else
		labelColor = {}
		dataColor = {}
		footerColor = {}
	end
	
	GameTooltip:AddLine("XToLevel")
	
	if cPlayer.level < cPlayer.maxLevel then
		GameTooltip:AddDoubleLine(LOCALE_TOOLTIP[LOCALE_DISPLAY]['Kills'] , NumberFormat(cPlayer:GetAverageKillsRemaining()), labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
		GameTooltip:AddDoubleLine(LOCALE_TOOLTIP[LOCALE_DISPLAY]['Quests'] , NumberFormat(cPlayer:GetAverageQuestsRemaining()), labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
		GameTooltip:AddLine(" ")
		
		if sConfig.ldb.tooltip.showDetails then
			GameTooltip:AddLine(LOCALE_TOOLTIP[LOCALE_DISPLAY]['Details'])
			GameTooltip:AddDoubleLine(LOCALE_TOOLTIP[LOCALE_DISPLAY]['XpPerKill'] , NumberFormat(round(cPlayer:GetAverageKillXP(), 0)), labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
			GameTooltip:AddDoubleLine(LOCALE_TOOLTIP[LOCALE_DISPLAY]['XpPerQuest'] , NumberFormat(round(cPlayer:GetAverageQuestXP(), 0)), labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
			GameTooltip:AddLine(" ")
		end
		
		if sConfig.ldb.tooltip.showExperience then
			local xpProgress = round((cPlayer.currentXP or 0) / (cPlayer.maxXP or 1) * 100, 1)
			local xpNeededTotal = cPlayer.maxXP - cPlayer.currentXP
			local xpNeededActual = cPlayer:GetKillsRequired(1) or "~"
			
			GameTooltip:AddLine(LOCALE_TOOLTIP[LOCALE_DISPLAY]['Experience'])
			GameTooltip:AddDoubleLine(LOCALE_TOOLTIP[LOCALE_DISPLAY]['Progress'] , ShrinkNumber(UnitXP("player")) .. " / " .. ShrinkNumber(UnitXPMax("player")) .. " [" .. tostring(xpProgress) .. "%" .. "]", labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
			GameTooltip:AddDoubleLine(LOCALE_TOOLTIP[LOCALE_DISPLAY]['Rested'] , ShrinkNumber(cPlayer:IsRested() or 0), labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
			GameTooltip:AddDoubleLine(LOCALE_TOOLTIP[LOCALE_DISPLAY]['RequiredQuestXP'] , ShrinkNumber(xpNeededTotal), labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
			GameTooltip:AddDoubleLine(LOCALE_TOOLTIP[LOCALE_DISPLAY]['RequiredKillXP'] , ShrinkNumber(xpNeededActual), labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
			
			GameTooltip:AddLine(" ")
		end
	end
	
	if cPet.isActive then
		GameTooltip:AddLine(LOCALE_TOOLTIP[LOCALE_DISPLAY]['Pet'])
		GameTooltip:AddDoubleLine(LOCALE_TOOLTIP[LOCALE_DISPLAY]['Kills'] , NumberFormat(cPet:GetAverageKillsRemaining()), labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
		GameTooltip:AddDoubleLine(LOCALE_TOOLTIP[LOCALE_DISPLAY]['XpPerKill'] , NumberFormat(round(cPet:GetAverageKillXP(), 0)), labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
		
		local petXP, petMaxXP = GetPetExperience()
		GameTooltip:AddDoubleLine(LOCALE_TOOLTIP[LOCALE_DISPLAY]['Required'] , NumberFormat(round((petMaxXP or 0) - (petXP or 0))), labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
		GameTooltip:AddLine(" ")
	end
	
	GameTooltip:AddLine("Click to configure", footerColor.r, footerColor.g, footerColor.b)

	GameTooltip:Show()
end

function dataobj:OnLeave()
	tooltipFrame = nil
	GameTooltip:Hide()
end

function dataobj.OnClick(self, button)
	-- TODO: Do something more interesting here...
	cDisplay.Config.waterfall:Open('ConfigWindow', 'ldb')
end

function UpdateDataObject()
	if sConfig.ldb.showLabel then
		dataobj.label = "XToLevel"
	else
		dataobj.label = nil
	end
	
	if sConfig.ldb.showIcon then
		local iconName = (UnitFactionGroup("player") == "Alliance") and "INV_Jewelry_TrinketPVP_01" or "INV_Jewelry_TrinketPVP_02"
		dataobj.icon = "Interface\\Icons\\" .. iconName
	else
		dataobj.icon = nil
	end
	
	if sConfig.ldb.showText then
		if cPlayer.level >= cPlayer.maxLevel then
			if sConfig.ldb.text.petKills and cPet.isActive and cPet.level < cPet.maxLevel then
				-- Player at max level but has an active pet
				if sConfig.ldb.customColors then
					local labelColor = "ffffff"
					local petColor = "ffaa66"
					dataobj.text = string.format("|cFF%s%s %s:|r |cFF%s%s|r ", labelColor, LOCALE_MESSAGES[LOCALE_DISPLAY]['Pet'], LOCALE_MESSAGES[LOCALE_DISPLAY]['Kills'], petColor, round(cPet:GetAverageKillsRemaining()))
				else
					dataobj.text = string.format("%s %s: %s", LOCALE_MESSAGES[LOCALE_DISPLAY]['Pet'], LOCALE_MESSAGES[LOCALE_DISPLAY]['Kills'], round(cPet:GetAverageKillsRemaining()))
				end
			else
				-- Not data to display, hide.
				if sConfig.ldb.customColors then
					dataobj.text = "XToLevel |cFFaaaaaano data|r"
				else
					dataobj.text = "XToLevel, no data"
				end
			end
		else
			-- User is leveling, proceed normally.
			local text = {  }
			if sConfig.ldb.customColors then
				local labelColor = "ffffff"
				local playerColor = "aaffaa"
				local petColor = "ffaa66"
				local xpColor = "aaaaaa"
				text = {
					playerKills = string.format("|cFF%s%s:|r |cFF%s%%s|r ", labelColor, LOCALE_MESSAGES[LOCALE_DISPLAY]['Kills'], playerColor),
					playerPetKills = string.format("|cFF%s%s:|r |cFF%s%%s|r|cFF%s|r/|cFF%s%%s|r ", labelColor, LOCALE_MESSAGES[LOCALE_DISPLAY]['Kills'], playerColor, labelColor, petColor),
					petKills = string.format("|cFF%s%s %s:|r |cFF%s%%s|r ", labelColor, LOCALE_MESSAGES[LOCALE_DISPLAY]['Pet'], LOCALE_MESSAGES[LOCALE_DISPLAY]['Kills'], petColor),
					playerQuests = string.format("|cFF%s%s:|r |cFF%s%%s|r ", labelColor, LOCALE_MESSAGES[LOCALE_DISPLAY]['Quests'], playerColor),
					xpProgress = string.format("|cFF%s[%%s%%%%]|r", xpColor)
				}
			else
				text = {
					playerKills = string.format("%s: %%s ", tostring(LOCALE_MESSAGES[LOCALE_DISPLAY]['Kills'])),
					playerPetKills = string.format("%s: %%s/%%s ", tostring(LOCALE_MESSAGES[LOCALE_DISPLAY]['Kills'])),
					petKills = string.format("%s %s: %%s ", tostring(LOCALE_MESSAGES[LOCALE_DISPLAY]['Pet']), tostring(LOCALE_MESSAGES[LOCALE_DISPLAY]['Kills'])),
					playerQuests = string.format("%s: %%s ", tostring(LOCALE_MESSAGES[LOCALE_DISPLAY]['Quests'])),
					xpProgress = "[%s%%]"
				}
			end

			local newText = ""
			if sConfig.ldb.text.playerKills then
				if sConfig.ldb.text.petKills and cPet.isActive then
					newText = newText .. string.format(text.playerPetKills, (round(cPlayer:GetAverageKillsRemaining()) or "~"), (cPet:GetAverageKillsRemaining() or "~"))
				else 
					newText = newText .. string.format(text.playerKills, round(cPlayer:GetAverageKillsRemaining()) or "~")
				end
			elseif sConfig.ldb.text.playerKills and cPet.isActive then
				newText = newText .. string.format(text.petKills, round(cPet:GetAverageKillsRemaining()) or "~")
			end
			if sConfig.ldb.text.playerQuests then
				newText = newText .. string.format(text.playerQuests, round(cPlayer:GetAverageQuestsRemaining()) or "~")
			end
			if sConfig.ldb.text.xpPogress then
				newText = newText .. string.format(text.xpProgress, tostring(math.floor((UnitXP("player") or 0) / (UnitXPMax("player") or 1) * 100)))
			end
			dataobj.text = newText
		end
	else
		dataobj.text = nil
	end
end

frame:SetScript("OnUpdate", function(self, elap)
	updateIn = updateIn - elap
	if updateIn <= 0 then
		updateIn = UPDATE_INTERVAL
		UpdateDataObject()
		
		if tooltipFrame then
			dataobj.OnEnter(tooltipFrame)
		end
	end
end)